// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIPaginatorList;
import org.apache.myfaces.tobago.layout.Arrows;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import jakarta.faces.application.ProjectStage;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 Renders a paginator for direct links.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.PaginatorListTagDeclaration}.
 */
@Generated("component.stg")
public class UIPaginatorList
    extends AbstractUIPaginatorList  {

  private static final Tags TAG = Tags.paginatorList;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Output";


  enum PropertyKeys {
    markup,
    max,
    alwaysVisible,
    arrows,
    forComponent,
    customClass,
    tip,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Show this number of links, if available.
  <br>Default: <code>9</code>
  */
  public java.lang.Integer getMax() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.max);
    if (value != null) {
      return value.intValue();
    }
    return 9;
  }

  public void setMax(java.lang.Integer max) {
    getStateHelper().put(PropertyKeys.max, max);
  }

  /**
  Flag indicating that the control show should be displayed in call cases,
   whether it is necessary or not (if there are a low number of rows).
  <br>Default: <code>false</code>
  */
  public boolean isAlwaysVisible() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.alwaysVisible);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setAlwaysVisible(boolean alwaysVisible) {
    getStateHelper().put(PropertyKeys.alwaysVisible, alwaysVisible);
  }

  /**
  Show arrows at this control.
  <br>Default: <code>auto</code><br>Allowed Values: <code>auto,show,hide</code>
  */
  public org.apache.myfaces.tobago.layout.Arrows getArrows() {
    org.apache.myfaces.tobago.layout.Arrows arrows = (org.apache.myfaces.tobago.layout.Arrows) getStateHelper().eval(PropertyKeys.arrows);
    if (arrows != null) {
      return arrows;
    }
    return org.apache.myfaces.tobago.layout.Arrows.auto;
  }

  public void setArrows(org.apache.myfaces.tobago.layout.Arrows arrows) {
    getStateHelper().put(PropertyKeys.arrows, arrows);
  }

  /**
  Id of the component, this is related to.

  */
  public java.lang.String getFor() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.forComponent);
  }

  public void setFor(java.lang.String forComponent) {
    getStateHelper().put(PropertyKeys.forComponent, forComponent);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}